<?php

namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\ChecklistAgendService;

class ChecklistAgendController extends FMCrud{
    protected $dataSourceName = 'fcm_checklistagend';
    protected $ChecklistAgendService;
   
    public function __construct($crudService, $environment, ChecklistAgendService $ChecklistAgendService) {
        parent::__construct($crudService, $environment);
        $this->ChecklistAgendService = $ChecklistAgendService;
    }

    public function listTask(DTO\Request $request, DTO\Response $response){
        $params = $request->getParameters();
        $var = $this->ChecklistAgendService->listTask($params);
        $dtsVal = new DataSet("task", $var);
        $response->addDataSet($dtsVal);
    }

    public function infoTask(DTO\Request $request, DTO\Response $response){
        $params = $request->getParameters();
        $var = $this->ChecklistAgendService->infoTask($params);
        $dtsVal = new DataSet("task", $var);
        $response->addDataSet($dtsVal);
    }

    public function taskOfTheEmployee(DTO\Request $request, DTO\Response $response){
        $params = $request->getParameters();
        $var = $this->ChecklistAgendService->taskOfTheEmployee($params);
        $dtsVal = new DataSet("task", $var);
        $response->addDataSet($dtsVal);
    }

    public function transferTask(DTO\Request $request, DTO\Response $response){
        $params = $request->getParameters();
        $var = $this->ChecklistAgendService->transferTask($params);
        $dtsVal = new DataSet("status",array($var));
        $response->addDataSet($dtsVal);
    }
}

?>