<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;

class ChecklistAgendFactory {
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }

    public function listTask($param,$params) {
        $sql = "SELECT FCM_CHECKLISTAGEND.DTHORAAGEND, FCM_CHECKLISTAGEND.NMCHECKLISTAGEND, FCM_CHECKLISTAGEND.DTHRFINALAGEND, FCM_LOCALCLI.DSCORIDLOCAL FROM FCM_CHECKLISTAGEND
                  JOIN FCM_LOCALCLI
                    ON FCM_LOCALCLI.NRLOCALCLIENTE = FCM_CHECKLISTAGEND.NRLOCALCLIENTE
                 WHERE TRUNC(FCM_CHECKLISTAGEND.DTHORAAGEND) BETWEEN TO_DATE( :startPeriod, 'YYYY-MM-DD') AND TO_DATE( :finishPeriod, 'YYYY-MM-DD')
                   AND FCM_CHECKLISTAGEND.NRFUNCIONARIO = :nr
                 ".$params."
              ORDER BY DTHORAAGEND";
        
        $std = $this->connection->prepare($sql);
        $std->execute($param);
        return $std->fetchAll();
    }

    public function infoTask($param) {
        $sql = "SELECT FCM_LOCALCLI.NMLOCALCLIENTE, FCM_TIPOLOCALCLI.NMTIPOLOCALCLI, FCM_FUNCIONARIO.NMFUNCIONARIO, FCM_CHECKLISTAGEND.DTHORAAGEND,
        FCM_CHECKLISTAGEND.DTHRFINALAGEND
       FROM FCM_CHECKLISTAGEND
       JOIN FCM_LOCALCLI
         ON FCM_LOCALCLI.NRLOCALCLIENTE = FCM_CHECKLISTAGEND.NRLOCALCLIENTE
       JOIN FCM_TIPOLOCALCLI
         ON FCM_LOCALCLI.NRTIPOLOCALCLI = FCM_TIPOLOCALCLI.NRTIPOLOCALCLI
       JOIN FCM_FUNCIONARIO
         ON FCM_CHECKLISTAGEND.NRFUNCIONARIO = FCM_FUNCIONARIO.NRFUNCIONARIO
      WHERE TO_CHAR(FCM_CHECKLISTAGEND.DTHORAAGEND, 'YYYY-MM-DD HH24:MI:SS') = :startPeriod
        AND TO_CHAR(FCM_CHECKLISTAGEND.DTHRFINALAGEND, 'YYYY-MM-DD HH24:MI:SS') = :finishPeriod
        AND FCM_CHECKLISTAGEND.NMCHECKLISTAGEND = :nome
        AND FCM_CHECKLISTAGEND.NRFUNCIONARIO = :nr
   ORDER BY DTHORAAGEND";
        $std = $this->connection->prepare($sql);
        $std->execute($param);
        return $std->fetchAll();
    }

    public function taskOfTheEmployee($param,$periodoGer,$periodoCheck) {
        $sql = "SELECT ('V-' || FCM_GERENCIAMENTOCHK.NRGERENCIAMENTOCHK) as NRCHECKLISTAGEND,
                       ('Vistoria-' || FCM_GERENCIAMENTOCHK.NMGERENCIAMENTOCHK) as NMCHECKLISTAGEND, FCM_LOCALCLI.NMLOCALCLIENTE as NMLOCALCLIENTE,
                       FCM_GERENCIAMENTOCHK.DTHORAAGEND as DTHORAAGEND
                  FROM FCM_GERENCIAMENTOCHK
                  JOIN FCM_LOCALCLI
                    ON FCM_LOCALCLI.NRLOCALCLIENTE = FCM_GERENCIAMENTOCHK.NRLOCALCLIENTE
                WHERE FCM_GERENCIAMENTOCHK.NRFUNCIONARIO = :nr
                {$periodoGer}

                UNION
              
                SELECT TO_CHAR(FCM_CHECKLISTAGEND.NRCHECKLISTAGEND) as NRCHECKLISTAGEND, FCM_CHECKLISTAGEND.NMCHECKLISTAGEND as NMCHECKLISTAGEND,
                FCM_LOCALCLI.NMLOCALCLIENTE as NMLOCALCLIENTE, FCM_CHECKLISTAGEND.DTHORAAGEND as DTHORAAGEND
                  FROM FCM_CHECKLISTAGEND
                  JOIN FCM_LOCALCLI
                    ON FCM_LOCALCLI.NRLOCALCLIENTE = FCM_CHECKLISTAGEND.NRLOCALCLIENTE
                WHERE FCM_CHECKLISTAGEND.NRFUNCIONARIO = :nr
                {$periodoCheck}
              ORDER BY DTHORAAGEND";
        
        $std = $this->connection->prepare($sql);
        $std->execute($param);
        return $std->fetchAll();
    }

    public function transferTask($param) {
      $sql = "UPDATE FCM_CHECKLISTAGEND
                 SET NRFUNCIONARIO = ".$param['nr']."
               WHERE NRCHECKLISTAGEND IN (".$param['list'].")";
      
      $std = $this->connection->prepare($sql);
      $std->execute();
  }

  public function dadosTask($param) {
    $sql = "SELECT NRCHECKLISTAGEND, NRFUNCIONARIO, DTHORAAGEND
              FROM FCM_CHECKLISTAGEND
             WHERE NRCHECKLISTAGEND = ".$param;
    
    $std = $this->connection->prepare($sql);
    $std->execute();
    return $std->fetchAll();
  }
}

?>