<?php
namespace FM\Service;

use FM\Factory\SetoresFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;

class SetoresService {
    
    protected $SetoresFactory;
    protected $Environment;
    protected $newCode;
    
    public function __construct (SetoresFactory $SetoresFactory, Environment $Environment, NewCode $newCode) {
        $this->SetoresFactory  = $SetoresFactory;
        $this->Environment                  = $Environment;
        $this->newCode                      = $newCode;
    }

    public function getSectorsService($params){
        $validParam = '';
        
        if($params['sectorSearch'] != '' && $params['sectorSearch'] != null ) {
            $validParam = " WHERE UPPER(NMSETOR) LIKE UPPER('%".$params['sectorSearch']."%')";
        }
        
        $operadores = $this->SetoresFactory->getSectorsFactory($validParam);
        return $operadores;
    }
    
    public function sectorsListService(){
        $operadores = $this->SetoresFactory->sectorsListFactory();
        return $operadores;
    }
    
     public function createSectorService($nmsetor, $nrfuncresponsavel){
        
        $nrsetor = $this->newCode->getCodeByTableName('FCM_SETOR', 20, 1, 10, true);
        
        $sectorInfos = array(
            'NRSETOR' => $nrsetor,
            'NMSETOR' => $nmsetor,
            'NRFUNCRESPONSAVEL' => $nrfuncresponsavel,
            'IDATIVO' => 'S'
        );
        
        $operadores = $this->SetoresFactory->createSectorFactory($sectorInfos);
    }
    
    public function getSectorInfosService($nrsetor){
        $params = array (
          'NRSETOR' => $nrsetor   
        );
        
        $operadores = $this->SetoresFactory->getSectorInfosFactory($params);
        return $operadores;
    }
    
    public function updateSectorService($nrsetor, $nmsetor, $nrfuncresponsavel) {
        $params = array(
            'NRSETOR' => $nrsetor,
            'NMSETOR' => $nmsetor,
            'NRFUNCRESPONSAVEL' => $nrfuncresponsavel
        );
        
        $operadores = $this->SetoresFactory->updateSectorFactory($params);
    }
    
    public function deleteSectorsService($params){
        $cont = 0;
        
        foreach($params as $sectorX) {
            foreach($sectorX as $sector){
                $validParam = array (
                    'NRSETOR' => $sector
                );
                $validaLocal = $this->SetoresFactory->validSectorsInLocalFactory($validParam);
                $valida = $validaLocal[0]['VALIDA'];
        
                if($valida == 0){
                    $validaCheckList = $this->SetoresFactory->validSectorsInChecklistFactory($validParam);
                    $valida = $validaCheckList[0]['VALIDA'];
                    
                    if($valida == 0){
                        $validaRelacFunc = $this->SetoresFactory->validSectorsInRelacFuncFactory($validParam);
                        $valida = $validaRelacFunc[0]['VALIDA'];
                        
                        if($valida == 0){
                          $this->SetoresFactory->deleteSectorsFactory($validParam);
                        } else $cont = $cont + 1;
                        
                    } else $cont = $cont + 1;
                    
                } else $cont = $cont + 1;            
            }
        }
        // debugApi([$cont]);
        return $cont;
    }
    
    public function getLinkedLocalsService($params){

        $operadores = $this->SetoresFactory->getLinkedLocalsFactory($params);
        return $operadores;
    }
}
?>